POSIX_OPENPT(3)

NAME
posix_openpt - open a pseudo-terminal device

SYNOPSIS
#include <stdlib.h>
#include <fcntl.h>
int
posix_openpt(int oflag);

DESCRIPTION
The posix_openpt() function allocates a new pseudo-terminal and establishes a connection with its master device. After the pseudo-terminal has been allocated, the slave device should have the proper permissions before it can be used (see grantpt(3)). The name of the slave device can be determined by calling ptsname(3).

The file status flags and file access modes of the open file description shall be set according to the value of oflag. Values for oflag are constructed by a bitwise-inclusive OR of flags from the following list, defined in <fcntl.h>:

O_RDWR
    Open for reading and writing.

O_NOCTTY
    If set posix_openpt() shall not cause the terminal device to become the controlling terminal for the process.

The posix_openpt() function shall fail when oflag contains other values.

RETURN VALUES
Upon successful completion, the posix_openpt() function shall allocate a new pseudo-terminal device and return a non-negative integer representing a file descriptor, which is connected to its master device. Otherwise, -1 shall be returned and errno set to indicate the error.

ERRORS
The posix_openpt() function shall fail if:

[EMFILE]
    The per-process descriptor table is full.

[ENFILE]
    The system file table is full.

[EINVAL]
    The value of oflag is not valid.

SEE ALSO
ptsname(3), pty(4), tty(4)

STANDARDS
The posix_openpt() function conforms to p1003.1-2001.

HISTORY
The posix_openpt() function appeared in OpenBSD 5.3.

CAVEATS
The flag O_NOCTTY is included for compatibility; in OpenBSD, opening a terminal does not cause it to become a process's controlling terminal.